



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Linux内存管理2---段机制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Linux内存管理2---段机制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 12:24:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>1.前言</h1>
<p>本文所述关于内存管理的系列文章主要是对陈莉君老师所讲述的内存管理知识讲座的整理。</p>
<p>本讲座主要分三个主题展开对内存管理进行讲解：内存管理的硬件基础、虚拟地址空间的管理、物理地址空间的管理.</p>
<p>本文将主要以X86架构为例来介绍Linux内存管理的段机制。</p>
<h1>2.段机制</h1>
<ul><li>段是虚拟地址空间的基本单位</li></ul>
<ul><li>段机制必须把虚拟地址空间的一个地址转换为线性地址空间的一个线性地址</li></ul>
<ul><li>段描述符</li></ul>
<blockquote><p>段的基地址（Base）：在线性地址空间中段的起始地址；</p>
<p>段的界限（Limit）：在虚拟地址空间中，段内可以使用的最大偏移量；</p>
<p>段的保护属性：表示段的特性。例如该段是否可以被读出或写入。或者该段是否可以作为一个程序来执行，以及段的特权等级</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1138116/201707/1138116-20170715150130431-2078589728.png" /></p>
<p>图 段描述符的一般格式</p></blockquote>
<ul><li>段描述符表</li></ul>
<blockquote><p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1138116/201707/1138116-20170715151049978-1006112004.png" /></p>
<p>图 段描述符表（段表）</p>
<p>索引描述虚拟地址空间段的编号；基地址是线性地址空间段的起始地址</p></blockquote>
<p>补充：保护模式下段描述符表分为：</p>
<p>全局描述符表（GDT）</p>
<p>中断描述符表（IDT）</p>
<p>局部描述符表（LDT）</p>
<p>注：为加快对如上描述符表的访问，intel为之设计了专门的寄存器，存放描述符表的基地址及表的长度界限</p>
<ul><li>保护模式下的段寄存器</li></ul>
<blockquote><p>段寄存器存放段描述符表的索引（段号，也叫选择符），即从段描述符表中选择某个段.</p>
<p>其中:</p>
<p>索引（13位指明段号）；</p>
<p>TI(Table Index)指明使用全局描述符表还是局部描述符表；</p>
<p>RPL(Requestor Previlege Level)：2位指定4种特权级，用来决定内核态还是用户态</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1138116/201707/1138116-20170715152818572-952699252.png" /></p>
<p>图 保护模式下的段寄存器</p></blockquote>
<ul><li>保护模式下的特权级</li></ul>
<blockquote><p>保护模式提供了四个特权级，用0~3四个数字表示</p>
<p>一般操作系统只使用了其中最低和最高两个，即0表示最高特权级，内核态；3表示最低特权级，用户态</p>
<p>保护模式规定高特权级可随意访问低特权级，低特权级不能随便访问高特权级</p></blockquote>
<ul><li>地址转换及保护</li></ul>
<blockquote><p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1138116/201707/1138116-20170715155115759-572597205.png" /></p>
<p>图 地址转换</p>
<p>程序中的虚拟地址可以表示为&ldquo;选择符：偏移量&rdquo;这样的形式，通过以下步骤可以把一个虚拟地址转换为线性地址：</p>
<p>　　（1）在段寄存器（16位选择器）中装入段选择符，同时把32位地址偏移量装入某个寄存器(比如ESI、EDI等)中。</p>
<p>　　（2）根据选择符中的索引值、TI及RPL值，再根据相应描述符表中的段基地址和段界限，进行一系列合法性检查(如特权级检查、界限检查)，如果该段无问题，就取出相应的描述符放入段描述符高速缓冲寄存器中。</p>
<p>　　（3）将描述符中的32位段基地址和放在ESI、EDI等中的32位有效地址（偏移量）相加，就形成了32位线性地址。</p>
<p>　　注意，在上面的地址转换过程中，从两个方面对段进行了保护：</p>
<p>　　（1） 在一个段内，如果偏移量大于段界限，虚拟地址将没有意义，系统将产生异常。</p>
<p>　　（2） 如果要对一个段进行访问，系统会根据段的保护属性检查访问者是否具有访问权限，如果没有，则产生异常。例如，如果要在只读段中进行写入，系统将根据该段的属性检测到这是一种违规操作，则产生异常。</p></blockquote>
<h1>3.Linux如何处理段</h1>
<p>Linux将整个虚拟地址空间划分为一个段，段的基地址为0，段的界限为4G。</p>
<p>由于很多体系结构并不要求段机制必选，因此这样处理即使用了段机制又巧妙的化解了段机制</p>
<ul><li>IA32上设计操作系统时无法回避使用段机制</li></ul>
<blockquote><p>在IA32上任意给出的地址都是一个虚拟地址，即任意一个地址都是通过&ldquo;选择符:偏移量&rdquo;的方式给出的，这是段机制存访问模式的基本特点</p>
<p>所以在IA32上设计操作系统时无法回避使用段机制，IA32规定段机制是不可禁止的，因此不可能绕过它直接给出线性地址空间的地址</p>
<p>一个虚拟地址最终会通过&ldquo;段基地址＋偏移量&rdquo;的方式转化为一个线性地址</p></blockquote>
<ul><li>为何要绕过段机制</li></ul>
<blockquote><p>由于绝大多数硬件平台都不支持段机制，只支持分页机制，所以为了让Linux具有更好的可移植性，我们需要去掉段机制而只使用分页机制</p></blockquote>
<ul><li>Linux如何绕过段机制　</li></ul>
<blockquote><p>Linux的设计人员干脆让段的基地址为0，而段的界限为4GB，这时任意给出一个偏移量，则等式为&ldquo;0+偏移量=线性地址&rdquo;，也就是说&ldquo;偏移量＝线性地址&rdquo;。</p>
<p>另外由于段机制规定&ldquo;偏移量 &lt;4GB&rdquo;，所以偏移量的范围为0H～FFFFFFFFH，这恰好是线性地址空间范围，也就是说虚拟地址直接映射到了线性地址，</p>
<p>我们以后所提到的虚拟地址和线性地址指的也就是同一地址。</p>
<p>看来，Linux在没有回避段机制的情况下巧妙地把段机制给绕过去了。</p></blockquote>
<ul><li>Linux所必须创建哪些段　　</li></ul>
<blockquote><p>由于IA32段机制还规定，必须为代码段和数据段创建不同的段，所以Linux必须为代码段和数据段分别创建一个基地址为0，段界限为4GB的段描述符。</p>
<p>不仅如此，由于Linux内核运行在特权级0，而用户程序运行在特权级别3，根据IA32的段保护机制规定，特权级3的程序是无法访问特权级为0的段的，所以Linux必须为内核和用户程序分别创建其代码段和数据段。</p>
<p>这就意味着Linux必须创建4个段描述符&mdash;&mdash;特权级0的代码段和数据段，特权级3的代码段和数据段。</p></blockquote>
<ul><li>Linux通过分页机制来保护内存　　</li></ul>
<blockquote><p>如果如上这样定义段，则上一节所说的段保护的第一个作用就失去了，因为这些段使用完全相同的线性地址空间（0～4GB），它们互相覆盖。</p>
<p>可以设想，如果不使用分页的话，线性地址空间直接被映射到物理空间，则你修改任何一个段的数据，都会同时修改其它段的数据</p>
<p>段机制所提供的通过&ldquo;基地址：界限&rdquo;方式本来将线性地址空间分割，以让段与段之间完全隔离，这种实现段保护的方式根本就不起作用了。</p>
<p>那么，这是不是意味着用户可以随意修改内核数据？显然不是的，这是因为，一方面用户段和内核段具有不同的特权级别，另一方面，Linux之所以这么定义段，正是为了实现一个纯的分页，而分页机制会提供给我们所需要的保护。</p></blockquote>
<h1>4.参考文献</h1>
<p>[1] Linux内存管理讲座PPT-陈莉君</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9j2xmw8.html">php捕捉来自搜索引擎的用户IP地址时间和访问路径</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7wjd19.html">（七）理解angular中的module和injector，即依赖注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwmn5y8.html">mysq常见问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/495oyre8.html">Python&colon; Catch multiple exceptions in one line &lpar;except block&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1ood19.html">关于查询oracle in &amp;gt&semi;1000 的讨论</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1o3g19.html">XMLParser解析xml--内容源自网络&lpar;在静态库中不能用GDATA来解析&comma;因为静态库不能加动态库&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn4dwrq.html">leetcode https&colon;&sol;&sol;oj&period;leetcode&period;com&sol;problems&sol;jump-game-ii&sol;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd77rr8.html">spring boot 下 500 404 错误页面处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljv2p19.html">Redux源码分析之bindActionCreators</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z5vdj9.html">TR069网管协议应用在Android系统开发的前言</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyrnxv9.html">简单的复用accep</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20r6y9.html">conda 安装多个版本的python</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvw45l8.html">Django进阶之QuerySet和中介模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rxj0j9.html">【转】C&num;中base关键字的几种用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/953rwzz8.html">MVC 拦截指定的action</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pg3d5q.html">有关C&plus;&plus;的数据类型（int&comma;long&comma;short&comma;float&comma;double等等）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qve1loy9.html">Idea不能新建package的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/953gj508.html">（原&rpar;ubuntu中安装kate</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx2el2j8.html">CentOS6编译安装Python3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlxp1y9.html">OS X 10&period;10&period;4系统，命名为&OpenCurlyDoubleQuote;Yosemite&rdquo;（优胜美地）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gy4o6q.html">19 Zabbix web监控实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5mjndq.html">监控&lpar;3&rpar;进程通用shell</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjl1l39.html">平台加载面板的方法&dollar;&period;loadPml</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy21n39.html">vue使用v-if v-show页面闪烁，div闪现的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll2jv0q.html">集合类（常见的集合类：Collection、List、Set、ArrayList、linkedList、Vector、HashSet、TreeSet）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7owz2x8.html">02-css的选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjlm569.html">Java 基础生词表</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e475px9.html">MQ问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvk5338.html">Docker-03 docker 加速器--DaoCloud 1&period;0</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjlvmr9.html">日志的使用-log4j</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
